/***************************************************************
*
*  Javascript functions regarding the permissions module
*  Relies on the javascript library "prototype"
*
*  Copyright notice
*
*  (c) 2007-2008	Andreas Beutel <typo3@mehrwert.de>
*  (c) 2007	Benjamin Mack <www.xnos.org>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * @author		Andreas Kundoch <typo3@mehrwert.de>
 * @author		Benjamin Mack <www.xnos.org>
 * @package		TYPO3
 * @subpackage	core
 * @version 	$Id: index.php 3074 2008-02-05 16:46:59Z patrickbroens $
 */

// TYPO3 code extracted from index.php
function checkChange(checknames, varname)	{
	var res = 0;
	for (var a=1; a<=5; a++)	{
		if (document.editform[checknames+"["+a+"]"].checked)	{
			res|=Math.pow(2,a-1);
		}
	}
	document.editform[varname].value = res | (checknames=="check[perms_user]"?1:0) ;
	setCheck(checknames,varname);
}

function setCheck(checknames, varname)	{
	if (document.editform[varname])	{
		var res = document.editform[varname].value;
		for (var a=1; a<=5; a++)	{
			document.editform[checknames+"["+a+"]"].checked = (res & Math.pow(2,a-1));
		}
	}
}

function jumpToUrl(URL)	{ window.location.href = URL; }

// Methods for AJAX permission manipulation
var WebPermissions = {

    thisScript: '../../../ajax.php',
	ajaxID: 'SC_mod_web_perm_ajax',

		// set the permissions by executing an ajax call
	setPermissions: function(page, bits, mode, who, permissions)	{
		new Ajax.Request(this.thisScript, {
			method: 'post',
			parameters: { ajaxID: this.ajaxID + '::dispatch', page: page, permissions: permissions, mode: mode, who: who, bits: bits },
			onSuccess: function(xhr)	{ $(page + "_" + who).innerHTML = xhr.responseText; },
			// onT3Error: function(xhr) { }.bind(this)
		});
	},

		// load the selector by executing an ajax call
	showChangeOwnerSelector: function(page, owner_uid, elementID, username) {
		new Ajax.Request(this.thisScript, {
			method: 'post',
			parameters: { ajaxID: this.ajaxID + '::dispatch', action: 'show_change_owner_selector', page: page, owner_uid: owner_uid, username: username },
			onSuccess: function(xhr) { $(elementID).innerHTML = xhr.responseText; },
			// onT3Error: function(xhr) { }.bind(this)
		});
	},

		// Set the new owner by executing an ajax call
	changeOwner: function(page, owner_uid, elementID) {
		new Ajax.Request(this.thisScript, {
			method: 'post',
			parameters: { ajaxID: this.ajaxID + '::dispatch', action: 'change_owner', page: page, owner_uid: owner_uid, owner_data: $('new_page_owner').serialize(true) },
			onSuccess: function(xhr) {	$(elementID).innerHTML = xhr.responseText; },
			// onT3Error: function(xhr) { }.bind(this)
		});
	},

		// Update the HTML view and show the original owner
	restoreOwner: function(page, owner_uid, username, elementID) {
		$(elementID).innerHTML = "<span id=\"o_" + page + "_" + owner_uid + "\"><a class=\"ug_selector\" onclick=\"WebPermissions.showChangeOwnerSelector('"+page+"', '"+owner_uid+"', 'o_"+page+"_"+owner_uid+"', '"+username+"');\">"+username+"</a></span>";
	},

		// Load the selector by executing an ajax call
	showChangeGroupSelector: function(page, group_uid, elementID, groupname) {
		new Ajax.Request(this.thisScript, {
			method: 'post',
			parameters: { ajaxID: this.ajaxID + '::dispatch', action: 'show_change_group_selector', page: page, group_uid: group_uid, groupname: groupname },
			onSuccess: function(xhr) {	$(elementID).innerHTML = xhr.responseText; },
			// onT3Error: function(xhr) { }.bind(this)
		});
	},

		// Set the new group by executing an ajax call
	changeGroup: function(page, group_uid, elementID) {
		new Ajax.Request(this.thisScript, {
			method: 'post',
			parameters: { ajaxID: this.ajaxID + '::dispatch', action: 'change_group', page: page, group_uid: group_uid, group_data: $('new_page_group').serialize(true) },
			onSuccess: function(xhr) {	$(elementID).innerHTML = xhr.responseText;	},
			// onT3Error: function(xhr) { }.bind(this)
		});
	},

		// Update the HTML view and show the original group
	restoreGroup: function(page, group_uid, groupname, elementID) {
		$(elementID).innerHTML = "<span id=\"g_" + page + "_" + group_uid + "\"><a class=\"ug_selector\" onclick=\"WebPermissions.showChangeGroupSelector('"+page+"', '"+group_uid+"', 'g_"+page+"_"+group_uid+"', '"+groupname+"');\">"+groupname+"</a></span>";
	},

		// set or remove the edit lock by executing an ajax call
	toggleEditLock: function(page, editlockstate)	{
		new Ajax.Request(this.thisScript, {
			method: 'post',
			parameters: { ajaxID: this.ajaxID + '::dispatch', action: 'toggle_edit_lock', page: page, editlockstate: editlockstate },
			onSuccess: function(xhr)	{ $("el_" + page).innerHTML = xhr.responseText; },
			// onT3Error: function(xhr) { }.bind(this)
		});
	}

};
